;     Weihnachtsmann Polonese
; -------------------------------
;  Entry for the XMas-PureContest
;
;     (c)Y2K3 benny /
;          weltenkonstrukteur.de
;
; -------------------------------
;
; MAIN

IncludeFile "proc_DoMenu.pb"
IncludeFile "proc_DoGame.pb"
IncludeFile "proc_DoText.pb"
IncludeFile "coolfont.pb"

;############################################################################
;-Inits

If InitSprite()=0  Or InitKeyboard()=0 Or InitMouse()=0 Or InitSprite3D()=0
  MessageRequester("ERROR","Cant init DirectX !",#MB_ICONERROR):End 
EndIf 
If InitSound()=0
  MessageRequester ("ERROR", "SoundFailure", #MB_ICONERROR):End
EndIf

#screenX = 640                     ; Bildschirm_X
#screenY = 400                     ; Bildschirm_Y
#title = "Weihnachtsmann-Polonese - (c) Y2K3 by benny / weltenkonstrukteur.de" ; Titel

Global gamestate.l , fadeout.l, score.l, level.l, GameFont.l, counter.l, MenuFont.l, textcounter.l, modvol.l

quit = 0                           ; Solange quit = 0 -> MainLoop, ansonsten GameOver
gamestate =  0                    ; 0 = DoMenu()  
                                  ; 1 = PrepareGame()
                                  ; 2 = DoGame()  
                                  ; 3 = DoGameover()
fadeout = 0                       ; Variable fr den berblendFX
score = 0
counter = 0
textcounter = 0
modvol.l = 60

hwnd = OpenWindow(0, (GetSystemMetrics_(#SM_CXSCREEN)-#screenX)/2,(GetSystemMetrics_(#SM_CYSCREEN)-#screenY)/2, #screenX, #screenY,  #PB_Window_SystemMenu, #title)
If hwnd = 0
  End
EndIf
OpenWindowedScreen(hWnd,0,0,#screenX,#screenY,0,0,0)

SetFrameRate(60) 

;#############################################################################
;-LoadData

GameFont = CreateFont("Verdana",48,#FONT_NORMAL)
MenuFont = CreateFont("Verdana",24,#FONT_NORMAL)

;CatchSoundSamples
CatchSound(1, ?Sound1)
SoundFrequency(1, 12000)
CatchSound (2, ?Sound2)
CatchSound (3, ?Sound3)

;Santa Numero Eins
CatchSprite (0, ?santa0, 0)
CatchSprite (1, ?santa1, 0)
CatchSprite (2, ?santa2, 0)

For dummycolor=0 To 2
  TransparentSpriteColor(dummycolor, 32,156,0)
Next dummycolor

CatchSprite (3, ?log, 0)
TransparentSpriteColor(3, 0, 24, 64)

CatchSprite (4, ?snowman2, 0)
TransparentSpriteColor(4, 0, 0, 0)

CatchSprite (5, ?pole4, 0)
TransparentSpriteColor(5, 239, 239, 255)

CatchSprite (6, ?muecke1, 0)
TransparentSpriteColor(6, 0, 0, 0)

CatchSprite (7, ?present, 0)
TransparentSpriteColor(7, 0, 0, 0)

CatchSprite (10, ?para_front3, 0)
TransparentSpriteColor(10, 255, 0, 0)

CatchSprite (11, ?starbackground, 0)

CatchSprite (12, ?berga, 0)
TransparentSpriteColor(12, 255, 0, 0)

CatchSprite (13, ?bergb, 0)
TransparentSpriteColor(13, 255, 0, 0)

CatchSprite (14, ?startstars, 0)

CatchSprite (15, ?santaX, #PB_Sprite_Texture)

TransparentSpriteColor(15, 33,158,0)
CreateSprite3D(16,15)

;berblendFX
CreateSprite (17, 256, 256, #PB_Sprite_Texture)
StartDrawing(SpriteOutput(17))
  Box( 0, 0, 256, 256, RGB( 5, 5, 5))
StopDrawing() 
CreateSprite3D( 18, 17)

CreateSprite (20, 5, 40, 0)            ; Dummy Sprite
TransparentSpriteColor(20, 0, 0, 0)     ; Unsichtebar !


; Soundtrack
UnpackedModule2 = AllocateMemory(1, 20000)
Size = UnpackMemory(?module2, UnpackedModule2)
If size
  If CatchMXMModule(UnpackedModule2) 
    PlayMXMModule()
    MXMModuleVolume(modvol)
  EndIf
EndIf


;#############################################################################
;-MainLoop

While quit = 0
    FlipBuffers() 
    ExamineKeyboard() 

    xmaus.l = WindowMouseX()
    ymaus.l = WindowMouseY()

    If IsScreenActive() 
       Select gamestate
         Case 0
           DoMenu()
           DoText()
           ; Checkt, ob in die Region vom SantaClaus geklickt wird
           mb_left.l=getasynckeystate_(1)
           If mb_left=-32767 And xmaus.l < 250 And ymaus.l > 200
            gamestate = 1
            modvol = 60
           EndIf
         Case 1
           DoMenu()            
         Case 2
           DoGame(xmaus, ymaus)
         Case 3
           DoGame(xmaus, ymaus)
       EndSelect       
    EndIf 
    
     Select WindowEvent() 
       Case #WM_CLOSE
         quit = 2
     EndSelect 

     If KeyboardReleased(#PB_KEY_ESCAPE)
       quit = 2
     EndIf 
  
    Delay(1)
;    Delay(10)      ; Mehr freie CPU-Power
Wend

;#############################################################################
;-Free Stuff

FreeSound(1)
FreeSound(2)
FreeSound(3)
StopMXMModule()
CloseWindow(0) 
End

DataSection:
santa0:
IncludeBinary "Data/santa00.bmp"
santa1:
IncludeBinary "Data/santa01.bmp"
santa2:
IncludeBinary "Data/santa02.bmp"
log:
IncludeBinary "Data/log.bmp"
snowman2:
IncludeBinary "Data/snowman2.bmp"
pole4:
IncludeBinary "Data/pole4.bmp"
muecke1:
IncludeBinary "Data/muecke1.bmp"
present:
IncludeBinary "Data/present.bmp"
para_front3:
IncludeBinary "Data/para_front4.bmp"
starbackground:
IncludeBinary "Data/starbackground.bmp"
berga:
IncludeBinary "Data/berg-siloutteA.bmp"
bergb:
IncludeBinary "Data/berg-siloutteB.bmp"
startstars:
IncludeBinary "Data/startstars.bmp"
santaX:
IncludeBinary "Data/santaX.bmp"
module2:
IncludeBinary "Data/we-wish-u-a-merry.pak"
Sound1:
IncludeBinary "Data/boing2.wav"
Sound2:
IncludeBinary "Data/collectpresent.wav"
Sound3:
IncludeBinary "Data/santakill.wav"
EndDataSection

; ExecutableFormat=Windows
; UseIcon=H:\XMas\snowman.ico
; Executable=F:\Code\purebasic\Examples\XMas-Tst3.exe
; DisableDebugger
; EOF